class CustomSet() {

    var internals = mutableSetOf<Int>()

    constructor(vararg stuff: Int): this() {
        stuff.forEach { this.add(it) }
    }

    constructor(wrapped: Set<Int>): this() {
        wrapped.forEach { this.add(it) }
    }

    fun isEmpty(): Boolean = internals.isEmpty()

    fun isSubset(other: CustomSet): Boolean = other.internals.containsAll(internals)

    fun isDisjoint(other: CustomSet): Boolean {
        return if (this.internals.isNotEmpty() && other.internals.isNotEmpty()) {
            other.internals.all { it !in this.internals }
        } else true
    }

    fun contains(other: Int): Boolean = this.internals.contains(other)

    fun intersection(other: CustomSet): CustomSet = CustomSet(other.internals.intersect(this.internals))

    fun add(other: Int) {
        internals.add(other)
    }

    override fun equals(other: Any?) = if (other is CustomSet) {
        other.internals == internals
    } else {
        false
    }

    operator fun plus(other: CustomSet) = CustomSet(internals.plus(other.internals))

    operator fun minus(other: CustomSet) = CustomSet(this.internals.minus(other.internals))

    override fun hashCode() = javaClass.hashCode()
}
