object Yacht {

    fun solve(category: YachtCategory, vararg dices: Int): Int {
        return when (category) {
            YachtCategory.YACHT -> (if (dices.all { it == dices[0] }) 50 else 0)
            YachtCategory.ONES -> 1 * dices.filter { it == 1 }.size
            YachtCategory.TWOS -> 2 * dices.filter { it == 2 }.size
            YachtCategory.THREES -> 3 * dices.filter { it == 3 }.size
            YachtCategory.FOURS -> 4 * dices.filter { it == 4 }.size
            YachtCategory.FIVES -> 5 * dices.filter { it == 5 }.size
            YachtCategory.SIXES -> 6 * dices.filter { it == 6 }.size
            YachtCategory.FULL_HOUSE -> calcFullHouse(dices.toList())
            YachtCategory.FOUR_OF_A_KIND -> dices.toList()
                .groupingBy { it }.eachCount()
                .filter { (_, frequency) -> frequency >= 4 }.map { (value, frequency) -> value * frequency.coerceAtMost(4) }.getOrNull(0) ?: 0
            YachtCategory.LITTLE_STRAIGHT -> if (listOf(1,2,3,4,5) == dices.sorted()) 30 else 0
            YachtCategory.BIG_STRAIGHT -> if (listOf(2,3,4,5,6) == dices.sorted()) 30 else 0
            YachtCategory.CHOICE -> dices.sum()
        }
    }

    private fun calcFullHouse(dice: List<Int>): Int {
        val frequency = dice.groupingBy { it }.eachCount()
        val needsCalc = with(frequency) {
            Pair(any { (_, frequency) -> frequency == 3},
            any { (_, frequency) -> frequency == 2})
        }
        return if (needsCalc.first && needsCalc.second) {
            dice.sum()
        } else 0
    }
}


